-------------------------------------------------------------------------------
--|> CORE
--:: Core addon files where addon states and control are managed
-------------------------------------------------------------------------------
--|> UPVALUE GLOBALS
-------------------------------------------------------------------------------
local weizPVP = _G.weizPVP
local wipe = wipe
local C_UI_Reload = C_UI.Reload
local C_Timer_After = C_Timer.After

-------------------------------------------------------------------------------
--|> LOCAL FUNCTIONS
-------------------------------------------------------------------------------
--> Fire Splash Alert if it hasnt been seen.
local function CheckSplash()
    weizPVP:CheckSplash()
end
-------------------------------------------------------------------------------
--|> ON INITIALIZE ------------------------------------------------------------
-------------------------------------------------------------------------------
function weizPVP:OnInitialize()
    weizPVP:LoadDB()
    weizPVP:BuildUIElements()
    --> Check for new version Splash
    if weizPVP.Options.Addon.VersionSplashSeen ~= true then
        weizPVP:CreateSplashScreen()
        C_Timer_After(1, CheckSplash)
    end
end

-------------------------------------------------------------------------------
--|> ON ENABLE ----------------------------------------------------------------
-------------------------------------------------------------------------------
function weizPVP:OnEnable()
    weizPVP.ManageBarsDisplayed()
    weizPVP.HeaderFrame:Show()
    weizPVP.CoreFrame:Show()
    weizPVP.FooterFrame:Show()
    --> Enable Events
    weizPVP.EnableEvents()
    --> Pulse Timer
    weizPVP:ScheduleRepeatingTimer("PulseEvent", 2)
    --> Apply Saved Settings
    weizPVP:ApplySavedOptions()
    weizPVP.Addon.ENABLED = true
end

-------------------------------------------------------------------------------
--|> ON DISABLE ---------------------------------------------------------------
-------------------------------------------------------------------------------
function weizPVP:OnDisable()
    --> Hide frames
    weizPVP.HeaderFrame:Hide()
    weizPVP.CoreFrame:Hide()
    weizPVP.FooterFrame:Hide()
    --> Cancel Timers
    weizPVP:CancelAllTimers()
    --> Clear current player data
    weizPVP:ClearListData()
    --> Enable Events
    weizPVP.EnableEvents()
    --> Mark addon is disabled
    weizPVP.Addon.ENABLED = false
end

-------------------------------------------------------------------------------
--|> RESET ALL ----------------------------------------------------------------
-------------------------------------------------------------------------------
function weizPVP:ResetAll()
    if weizPVP.charDB then
        wipe(weizPVP.charDB)
    end
    if weizPVP.globalDB then
        wipe(weizPVP.globalDB)
    end
    if weizPVP.PlayerDB then
        wipe(weizPVP.PlayerDB)
    end
    if weizPVP.Options then
        wipe(weizPVP.Options)
    end
    wipe(weizPVP.charDB)
    wipe(weizPVP.globalDB)

    C_UI_Reload()
end

-------------------------------------------------------------------------------
--|> RESET OPTIONS ------------------------------------------------------------
-------------------------------------------------------------------------------
function weizPVP:ResetOptions()
    if weizPVP.Options then
        wipe(weizPVP.Options)
    end
    if wipe(weizPVP.charDB) then
        wipe((weizPVP.charDB))
    end
    C_UI_Reload()
end
