-------------------------------------------------------------------------------
--|> STATUS BAR
--:: Manages the messages in the StatusBar frame
-------------------------------------------------------------------------------
--|> UPVALUE GLOBALS
-------------------------------------------------------------------------------
local weizPVP = weizPVP
-------------------------------------------------------------------------------

--|> FUNCTIONS
-------------------------------------------------------------------------------
local textFadeIn
local textFadeOut

function weizPVP:CreateStatusBar()
    --> StatusFlash
    -----------------------------------------------------------------------
    --=> AnimationGroup: Fade Text
    -----------------------------------------------------------------------
    weizPVP.FooterFrame.Text.anim = weizPVP.FooterFrame.Text:CreateAnimationGroup()
    textFadeIn = weizPVP.FooterFrame.Text.anim:CreateAnimation("Alpha")
    textFadeIn:SetDuration(0.2)
    textFadeIn:SetFromAlpha(0)
    textFadeIn:SetToAlpha(1)
    textFadeIn:SetEndDelay(3) --> Set the number of seconds the animation delays after finishing.
    textFadeIn:SetOrder(1)

    textFadeOut = weizPVP.FooterFrame.Text.anim:CreateAnimation("Alpha")
    textFadeOut:SetDuration(2)
    textFadeOut:SetFromAlpha(1)
    textFadeOut:SetToAlpha(0)
    textFadeOut:SetOrder(2)
end

--=> Set Status Bar Message
function weizPVP:SetStatusBarMessage(stringSB, fadeEN, duration, debug)
    if debug then
        weizPVP.FooterFrame.Text:SetText("> |cffff3838DEBUG MODE ACTIVE|r <")
        weizPVP.FooterFrame.Text:SetAlpha(1)
        weizPVP.FooterFrame.Text:Show()
    else
        weizPVP.FooterFrame.Text:SetText(stringSB)
        if fadeEN then
            weizPVP.FooterFrame.Text.anim:Stop()
            weizPVP.FooterFrame.Text:SetAlpha(1)
            textFadeIn:SetEndDelay(duration)
            textFadeOut:SetToAlpha(0)
            weizPVP.FooterFrame.Text.anim:SetScript(
                "OnFinished",
                function()
                    weizPVP.FooterFrame.Text:SetAlpha(0)
                end
            )
        else
            textFadeOut:SetToAlpha(1)
            weizPVP.FooterFrame.Text.anim:SetScript(
                "OnFinished",
                function()
                    weizPVP.FooterFrame.Text:SetAlpha(1)
                end
            )
        end
        weizPVP.FooterFrame.Text.anim:Play()
    end
end
